ParagraphView (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: javax.swing.text.html, class: ParagraphView
Keywords: javax.swing.text.html.ParagraphView class

# Class ParagraphView

java.lang.Object
javax.swing.text.View
javax.swing.text.CompositeView
javax.swing.text.BoxView
javax.swing.text.FlowView
javax.swing.text.ParagraphView
javax.swing.text.html.ParagraphView

All Implemented Interfaces:
  `SwingConstants, TabExpander`

public class ParagraphView extends ParagraphView
Displays the paragraph and uses CSS attributes for its configuration.

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class FlowView

  `FlowView.FlowStrategy`
  Modifier and Type
  Class
  Description
  `static class`
  `FlowView.FlowStrategy`
  Strategy for maintaining the physical form of the flow.

- ## Field Summary

  ### Fields declared in class ParagraphView

  `firstLineIndent`
  Modifier and Type
  Field
  Description
  `protected int`
  `firstLineIndent`
  Indentation for the first line, from the left inset.

  ### Fields declared in class FlowView

  `layoutPool, layoutSpan, strategy`
  Modifier and Type
  Field
  Description
  `protected View`
  `layoutPool`
  These are the views that represent the child elements of the element this view represents (The logical view to translate to a physical view).
  `protected int`
  `layoutSpan`
  Default constraint against which the flow is created against.
  `protected FlowView.FlowStrategy`
  `strategy`
  The behavior for keeping the flow updated.

  ### Fields declared in class View

  `BadBreakWeight, ExcellentBreakWeight, ForcedBreakWeight, GoodBreakWeight, X_AXIS, Y_AXIS`
  Modifier and Type
  Field
  Description
  `static final int`
  `BadBreakWeight`
  The weight to indicate a view is a bad break opportunity for the purpose of formatting.
  `static final int`
  `ExcellentBreakWeight`
  The weight to indicate a view supports breaking, and this represents a very attractive place to break.
  `static final int`
  `ForcedBreakWeight`
  The weight to indicate a view supports breaking, and must be broken to be represented properly when placed in a view that formats its children by breaking them.
  `static final int`
  `GoodBreakWeight`
  The weight to indicate a view supports breaking, but better opportunities probably exist.
  `static final int`
  `X_AXIS`
  Axis for format/break operations.
  `static final int`
  `Y_AXIS`
  Axis for format/break operations.

  ### Fields declared in interface SwingConstants

  `BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NEXT, NORTH, NORTH_EAST, NORTH_WEST, PREVIOUS, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`
  Modifier and Type
  Field
  Description
  `static final int`
  `BOTTOM`
  Box-orientation constant used to specify the bottom of a box.
  `static final int`
  `CENTER`
  The central position in an area.
  `static final int`
  `EAST`
  Compass-direction east (right).
  `static final int`
  `HORIZONTAL`
  Horizontal orientation.
  `static final int`
  `LEADING`
  Identifies the leading edge of text for use with left-to-right and right-to-left languages.
  `static final int`
  `LEFT`
  Box-orientation constant used to specify the left side of a box.
  `static final int`
  `NEXT`
  Identifies the next direction in a sequence.
  `static final int`
  `NORTH`
  Compass-direction North (up).
  `static final int`
  `NORTH_EAST`
  Compass-direction north-east (upper right).
  `static final int`
  `NORTH_WEST`
  Compass-direction north west (upper left).
  `static final int`
  `PREVIOUS`
  Identifies the previous direction in a sequence.
  `static final int`
  `RIGHT`
  Box-orientation constant used to specify the right side of a box.
  `static final int`
  `SOUTH`
  Compass-direction south (down).
  `static final int`
  `SOUTH_EAST`
  Compass-direction south-east (lower right).
  `static final int`
  `SOUTH_WEST`
  Compass-direction south-west (lower left).
  `static final int`
  `TOP`
  Box-orientation constant used to specify the top of a box.
  `static final int`
  `TRAILING`
  Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
  `static final int`
  `VERTICAL`
  Vertical orientation.
  `static final int`
  `WEST`
  Compass-direction west (left).

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ParagraphView(Element elem)`
  Constructs a ParagraphView for the given element.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected SizeRequirements`
  `calculateMinorAxisRequirements(int axis, SizeRequirements r)`
  Calculate the needs for the paragraph along the minor axis.
  `AttributeSet`
  `getAttributes()`
  Fetches the attributes to use when rendering.
  `float`
  `getMaximumSpan(int axis)`
  Determines the maximum span for this view along an axis.
  `float`
  `getMinimumSpan(int axis)`
  Determines the minimum span for this view along an axis.
  `float`
  `getPreferredSpan(int axis)`
  Determines the preferred span for this view.
  `protected StyleSheet`
  `getStyleSheet()`
  Convenient method to get the StyleSheet.
  `boolean`
  `isVisible()`
  Indicates whether or not this view should be displayed.
  `void`
  `paint(Graphics g, Shape a)`
  Renders using the given rendering surface and area on that surface.
  `void`
  `setParent(View parent)`
  Establishes the parent view for this view.
  `protected void`
  `setPropertiesFromAttributes()`
  Sets up the paragraph from css attributes instead of the values found in StyleConstants (i.e. which are used by the superclass).

  ### Methods declared in class ParagraphView

  `breakView, changedUpdate, createRow, findOffsetToCharactersInString, flipEastAndWestAtEnds, getAlignment, getBreakWeight, getClosestPositionTo, getFlowSpan, getFlowStart, getLayoutView, getLayoutViewCount, getNextNorthSouthVisualPositionFrom, getPartialSize, getTabBase, getTabSet, nextTabStop, setFirstLineIndent, setJustification, setLineSpacing`
  Modifier and Type
  Method
  Description
  `View`
  `breakView(int axis, float len, Shape a)`
  Breaks this view on the given axis at the given length.
  `void`
  `changedUpdate(DocumentEvent changes, Shape a, ViewFactory f)`
  Gives notification from the document that attributes were changed in a location that this view is responsible for.
  `protected View`
  `createRow()`
  Create a `View` that should be used to hold a a row's worth of children in a flow.
  `protected int`
  `findOffsetToCharactersInString(char[] string, int start)`
  Finds the next character in the document with a character in `string`, starting at offset `start`.
  `protected boolean`
  `flipEastAndWestAtEnds(int position, Position.Bias bias)`
  Determines in which direction the next view lays.
  `float`
  `getAlignment(int axis)`
  Determines the desired alignment for this view along an axis.
  `int`
  `getBreakWeight(int axis, float len)`
  Gets the break weight for a given location.
  `protected int`
  `getClosestPositionTo(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet, int rowIndex, int x)`
  Returns the closest model position to `x`.
  `int`
  `getFlowSpan(int index)`
  Fetches the constraining span to flow against for the given child index.
  `int`
  `getFlowStart(int index)`
  Fetches the location along the flow axis that the flow span will start at.
  `protected View`
  `getLayoutView(int index)`
  Returns the view at a given `index`.
  `protected int`
  `getLayoutViewCount()`
  Returns the number of views that this view is responsible for.
  `protected int`
  `getNextNorthSouthVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
  Returns the next visual position for the cursor, in either the east or west direction.
  `protected float`
  `getPartialSize(int startOffset, int endOffset)`
  Returns the size used by the views between `startOffset` and `endOffset`.
  `protected float`
  `getTabBase()`
  Returns where the tabs are calculated from.
  `protected TabSet`
  `getTabSet()`
  Gets the `Tabset` to be used in calculating tabs.
  `float`
  `nextTabStop(float x, int tabOffset)`
  Returns the next tab stop position given a reference position.
  `protected void`
  `setFirstLineIndent(float fi)`
  Sets the indent on the first line.
  `protected void`
  `setJustification(int j)`
  Sets the type of justification.
  `protected void`
  `setLineSpacing(float ls)`
  Sets the line spacing.

  ### Methods declared in class FlowView

  `getFlowAxis, getViewIndexAtPosition, insertUpdate, layout, loadChildren, removeUpdate`
  Modifier and Type
  Method
  Description
  `int`
  `getFlowAxis()`
  Fetches the axis along which views should be flowed.
  `protected int`
  `getViewIndexAtPosition(int pos)`
  Fetches the child view index representing the given position in the model.
  `void`
  `insertUpdate(DocumentEvent changes, Shape a, ViewFactory f)`
  Gives notification that something was inserted into the document in a location that this view is responsible for.
  `protected void`
  `layout(int width, int height)`
  Lays out the children.
  `protected void`
  `loadChildren(ViewFactory f)`
  Loads all of the children to initialize the view.
  `void`
  `removeUpdate(DocumentEvent changes, Shape a, ViewFactory f)`
  Gives notification that something was removed from the document in a location that this view is responsible for.

  ### Methods declared in class BoxView

  `baselineLayout, baselineRequirements, calculateMajorAxisRequirements, childAllocation, forwardUpdate, getAxis, getChildAllocation, getHeight, getOffset, getResizeWeight, getSpan, getViewAtPoint, getWidth, isAfter, isAllocationValid, isBefore, isLayoutValid, layoutChanged, layoutMajorAxis, layoutMinorAxis, modelToView, paintChild, preferenceChanged, replace, setAxis, setSize, viewToModel`
  Modifier and Type
  Method
  Description
  `protected void`
  `baselineLayout(int targetSpan, int axis, int[] offsets, int[] spans)`
  Computes the location and extent of each child view in this `BoxView` given the `targetSpan`, which is the width (or height) of the region we have to work with.
  `protected SizeRequirements`
  `baselineRequirements(int axis, SizeRequirements r)`
  Calculates the size requirements for this `BoxView` by examining the size of each child view.
  `protected SizeRequirements`
  `calculateMajorAxisRequirements(int axis, SizeRequirements r)`
  Calculates the size requirements for the major axis `axis`.
  `protected void`
  `childAllocation(int index, Rectangle alloc)`
  Allocates a region for a child view.
  `protected void`
  `forwardUpdate(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a, ViewFactory f)`
  Forwards the given `DocumentEvent` to the child views that need to be notified of the change to the model.
  `int`
  `getAxis()`
  Fetches the tile axis property.
  `Shape`
  `getChildAllocation(int index, Shape a)`
  Fetches the allocation for the given child view.
  `int`
  `getHeight()`
  Returns the current height of the box.
  `protected int`
  `getOffset(int axis, int childIndex)`
  Fetches the offset of a particular child's current layout.
  `int`
  `getResizeWeight(int axis)`
  Gets the resize weight.
  `protected int`
  `getSpan(int axis, int childIndex)`
  Fetches the span of a particular child's current layout.
  `protected View`
  `getViewAtPoint(int x, int y, Rectangle alloc)`
  Fetches the child view at the given coordinates.
  `int`
  `getWidth()`
  Returns the current width of the box.
  `protected boolean`
  `isAfter(int x, int y, Rectangle innerAlloc)`
  Determines if a point falls after an allocated region.
  `protected boolean`
  `isAllocationValid()`
  Are the allocations for the children still valid?
  `protected boolean`
  `isBefore(int x, int y, Rectangle innerAlloc)`
  Determines if a point falls before an allocated region.
  `protected boolean`
  `isLayoutValid(int axis)`
  Determines if the layout is valid along the given axis.
  `void`
  `layoutChanged(int axis)`
  Invalidates the layout along an axis.
  `protected void`
  `layoutMajorAxis(int targetSpan, int axis, int[] offsets, int[] spans)`
  Performs layout for the major axis of the box (i.e. the axis that it represents).
  `protected void`
  `layoutMinorAxis(int targetSpan, int axis, int[] offsets, int[] spans)`
  Performs layout for the minor axis of the box (i.e. the axis orthogonal to the axis that it represents).
  `Shape`
  `modelToView(int pos, Shape a, Position.Bias b)`
  Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
  `protected void`
  `paintChild(Graphics g, Rectangle alloc, int index)`
  Paints a child.
  `void`
  `preferenceChanged(View child, boolean width, boolean height)`
  This is called by a child to indicate its preferred span has changed.
  `void`
  `replace(int index, int length, View[] elems)`
  Invalidates the layout and resizes the cache of requests/allocations.
  `void`
  `setAxis(int axis)`
  Sets the tile axis property.
  `void`
  `setSize(float width, float height)`
  Sets the size of the view.
  `int`
  `viewToModel(float x, float y, Shape a, Position.Bias[] bias)`
  Provides a mapping from the view coordinate space to the logical coordinate space of the model.

  ### Methods declared in class CompositeView

  `getBottomInset, getInsideAllocation, getLeftInset, getNextEastWestVisualPositionFrom, getNextVisualPositionFrom, getRightInset, getTopInset, getView, getViewAtPosition, getViewCount, getViewIndex, modelToView, setInsets, setParagraphInsets`
  Modifier and Type
  Method
  Description
  `protected short`
  `getBottomInset()`
  Gets the bottom inset.
  `protected Rectangle`
  `getInsideAllocation(Shape a)`
  Translates the immutable allocation given to the view to a mutable allocation that represents the interior allocation (i.e. the bounds of the given allocation with the top, left, bottom, and right insets removed.
  `protected short`
  `getLeftInset()`
  Gets the left inset.
  `protected int`
  `getNextEastWestVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
  Returns the next visual position for the cursor, in either the east or west direction.
  `int`
  `getNextVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
  Provides a way to determine the next visually represented model location that one might place a caret.
  `protected short`
  `getRightInset()`
  Gets the right inset.
  `protected short`
  `getTopInset()`
  Gets the top inset.
  `View`
  `getView(int n)`
  Returns the n-th view in this container.
  `protected View`
  `getViewAtPosition(int pos, Rectangle a)`
  Fetches the child view that represents the given position in the model.
  `int`
  `getViewCount()`
  Returns the number of child views of this view.
  `int`
  `getViewIndex(int pos, Position.Bias b)`
  Returns the child view index representing the given position in the model.
  `Shape`
  `modelToView(int p0, Position.Bias b0, int p1, Position.Bias b1, Shape a)`
  Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
  `protected void`
  `setInsets(short top, short left, short bottom, short right)`
  Sets the insets for the view.
  `protected void`
  `setParagraphInsets(AttributeSet attr)`
  Sets the insets from the paragraph attributes specified in the given attributes.

  ### Methods declared in class View

  `append, breakView, createFragment, forwardUpdateToView, getBreakWeight, getContainer, getDocument, getElement, getEndOffset, getGraphics, getParent, getStartOffset, getToolTipText, getViewFactory, getViewIndex, insert, modelToView, remove, removeAll, updateChildren, updateLayout, viewToModel`
  Modifier and Type
  Method
  Description
  `void`
  `append(View v)`
  Appends a single child view.
  `View`
  `breakView(int axis, int offset, float pos, float len)`
  Tries to break this view on the given axis.
  `View`
  `createFragment(int p0, int p1)`
  Creates a view that represents a portion of the element.
  `protected void`
  `forwardUpdateToView(View v, DocumentEvent e, Shape a, ViewFactory f)`
  Forwards the `DocumentEvent` to the give child view.
  `int`
  `getBreakWeight(int axis, float pos, float len)`
  Determines how attractive a break opportunity in this view is.
  `Container`
  `getContainer()`
  Fetches the container hosting the view.
  `Document`
  `getDocument()`
  Fetches the model associated with the view.
  `Element`
  `getElement()`
  Fetches the structural portion of the subject that this view is mapped to.
  `int`
  `getEndOffset()`
  Fetches the portion of the model for which this view is responsible.
  `Graphics`
  `getGraphics()`
  Fetch a `Graphics` for rendering.
  `View`
  `getParent()`
  Returns the parent of the view.
  `int`
  `getStartOffset()`
  Fetches the portion of the model for which this view is responsible.
  `String`
  `getToolTipText(float x, float y, Shape allocation)`
  Returns the tooltip text at the specified location.
  `ViewFactory`
  `getViewFactory()`
  Fetches the `ViewFactory` implementation that is feeding the view hierarchy.
  `int`
  `getViewIndex(float x, float y, Shape allocation)`
  Returns the child view index representing the given position in the view.
  `void`
  `insert(int offs, View v)`
  Inserts a single child view.
  `Shape`
  `modelToView(int pos, Shape a)`
  Deprecated.
  `void`
  `remove(int i)`
  Removes one of the children at the given position.
  `void`
  `removeAll()`
  Removes all of the children.
  `protected boolean`
  `updateChildren(DocumentEvent.ElementChange ec, DocumentEvent e, ViewFactory f)`
  Updates the child views in response to receiving notification that the model changed, and there is change record for the element this view is responsible for.
  `protected void`
  `updateLayout(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a)`
  Updates the layout in response to receiving notification of change from the model.
  `int`
  `viewToModel(float x, float y, Shape a)`
  Deprecated.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### ParagraphView

    public ParagraphView(Element elem)
    Constructs a ParagraphView for the given element.
    Parameters:
      `elem` - the element that this view is responsible for

- ## Method Details

  - ### setParent

    public void setParent(View parent)
    Establishes the parent view for this view. This is guaranteed to be called before any other methods if the parent view is functioning properly.

    This is implemented to forward to the superclass as well as call the `setPropertiesFromAttributes` method to set the paragraph properties from the css attributes. The call is made at this time to ensure the ability to resolve upward through the parents view attributes.

    Overrides:
      `setParent` in class `CompositeView`
    Parameters:
      `parent` - the new parent, or null if the view is being removed from a parent it was previously added to

  - ### getAttributes

    public AttributeSet getAttributes()
    Fetches the attributes to use when rendering. This is implemented to multiplex the attributes specified in the model with a StyleSheet.
    Overrides:
      `getAttributes` in class `View`
    Returns:
      the attributes to use when rendering

  - ### setPropertiesFromAttributes

    protected void setPropertiesFromAttributes()
    Sets up the paragraph from css attributes instead of the values found in StyleConstants (i.e. which are used by the superclass). Since
    Overrides:
      `setPropertiesFromAttributes` in class `ParagraphView`

  - ### getStyleSheet

    protected StyleSheet getStyleSheet()
    Convenient method to get the StyleSheet.
    Returns:
      the StyleSheet

  - ### calculateMinorAxisRequirements

    protected SizeRequirements calculateMinorAxisRequirements(int axis, SizeRequirements r)
    Calculate the needs for the paragraph along the minor axis.

    If size requirements are explicitly specified for the paragraph, use that requirements. Otherwise, use the requirements of the superclass `ParagraphView`.

    If the `axis` parameter is neither `View.X_AXIS` nor `View.Y_AXIS`, `IllegalArgumentException` is thrown. If the `r` parameter is `null,` a new `SizeRequirements` object is created, otherwise the supplied `SizeRequirements` object is returned.

    Overrides:
      `calculateMinorAxisRequirements` in class `ParagraphView`
    Parameters:
      `axis` - the minor axis
      `r` - the input `SizeRequirements` object
    Returns:
      the new or adjusted `SizeRequirements` object
    Throws:
      `IllegalArgumentException` - if the `axis` parameter is invalid
    See Also:
      - `SizeRequirements`

  - ### isVisible

    public boolean isVisible()
    Indicates whether or not this view should be displayed. If none of the children wish to be displayed and the only visible child is the break that ends the paragraph, the paragraph will not be considered visible. Otherwise, it will be considered visible and return true.
    Overrides:
      `isVisible` in class `View`
    Returns:
      true if the paragraph should be displayed

  - ### paint

    public void paint(Graphics g, Shape a)
    Renders using the given rendering surface and area on that surface. This is implemented to delegate to the superclass after stashing the base coordinate for tab calculations.
    Overrides:
      `paint` in class `ParagraphView`
    Parameters:
      `g` - the rendering surface to use
      `a` - the allocated region to render into
    See Also:
      - `View.paint(Graphics, Shape)`

  - ### getPreferredSpan

    public float getPreferredSpan(int axis)
    Determines the preferred span for this view. Returns 0 if the view is not visible, otherwise it calls the superclass method to get the preferred span. axis.
    Overrides:
      `getPreferredSpan` in class `BoxView`
    Parameters:
      `axis` - may be either View.X_AXIS or View.Y_AXIS
    Returns:
      the span the view would like to be rendered into; typically the view is told to render into the span that is returned, although there is no guarantee; the parent may choose to resize or break the view
    See Also:
      - `BoxView.getPreferredSpan(int)`

  - ### getMinimumSpan

    public float getMinimumSpan(int axis)
    Determines the minimum span for this view along an axis. Returns 0 if the view is not visible, otherwise it calls the superclass method to get the minimum span.
    Overrides:
      `getMinimumSpan` in class `BoxView`
    Parameters:
      `axis` - may be either `View.X_AXIS` or `View.Y_AXIS`
    Returns:
      the minimum span the view can be rendered into
    See Also:
      - `BoxView.getMinimumSpan(int)`

  - ### getMaximumSpan

    public float getMaximumSpan(int axis)
    Determines the maximum span for this view along an axis. Returns 0 if the view is not visible, otherwise it calls the superclass method ot get the maximum span.
    Overrides:
      `getMaximumSpan` in class `BoxView`
    Parameters:
      `axis` - may be either `View.X_AXIS` or `View.Y_AXIS`
    Returns:
      the maximum span the view can be rendered into
    See Also:
      - `BoxView.getMaximumSpan(int)`